Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Classes | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::WidenOp< A > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2 >
HALIDE_ALWAYS_INLINE bool | match (const WidenOp< A2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const

## Public Attributes
A | a

## Static Public Attributes
static constexpr uint32_t | binds = bindings<A>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Cast
static constexpr IRNodeType | max_node_type = IRNodeType::Cast
static constexpr bool | canonical = A::canonical
static constexpr bool | foldable = false

## Detailed Description

template<typename A>
struct Halide::Internal::IRMatcher::WidenOp< A >

Definition at line 2142 of file IRMatch.h.

## Member Function Documentation

## ◆ match() [1/2]

template<typename A >
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::WidenOp< A >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 2153 of file IRMatch.h.

References Halide::Internal::Cast::_node_type, Halide::Internal::IRMatcher::WidenOp< A >::a, Halide::Internal::IRMatcher::cast(), Halide::Expr::get(), Halide::Expr::type(), Halide::Internal::Cast::value, and Halide::Type::widen().

## ◆ match() [2/2]

template<typename A >
template<uint32_t bound, typename A2 >

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::WidenOp< A >::match | ( | const WidenOp< A2 > & | op,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 2162 of file IRMatch.h.

References Halide::Internal::IRMatcher::WidenOp< A >::a, Halide::Internal::IRMatcher::cast(), and Halide::Internal::IRMatcher::unwrap().

## ◆ make()

template<typename A >

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::WidenOp< A >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 2167 of file IRMatch.h.

References Halide::Internal::IRMatcher::WidenOp< A >::a, Halide::Internal::IRMatcher::cast(), Halide::Expr::type(), and Halide::Type::widen().

## Member Data Documentation

## ◆ a

template<typename A >

A Halide::Internal::IRMatcher::WidenOp< A >::a

Definition at line 2144 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::WidenOp< A >::make(), Halide::Internal::IRMatcher::WidenOp< A >::match(), Halide::Internal::IRMatcher::WidenOp< A >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ binds

template<typename A >

constexpr uint32_t Halide::Internal::IRMatcher::WidenOp< A >::binds = bindings<A>::mask
| static constexpr

Definition at line 2146 of file IRMatch.h.

## ◆ min_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::WidenOp< A >::min_node_type = IRNodeType::Cast
| static constexpr

Definition at line 2148 of file IRMatch.h.

## ◆ max_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::WidenOp< A >::max_node_type = IRNodeType::Cast
| static constexpr

Definition at line 2149 of file IRMatch.h.

## ◆ canonical

template<typename A >

constexpr bool Halide::Internal::IRMatcher::WidenOp< A >::canonical = A::canonical
| static constexpr

Definition at line 2150 of file IRMatch.h.

## ◆ foldable

template<typename A >

constexpr bool Halide::Internal::IRMatcher::WidenOp< A >::foldable = false
| static constexpr

Definition at line 2173 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h